/* Problem URL: https://codeforces.com/problemset/problem/1735/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k;
    cin >> n >> k;

    vvi fds(n, vi(k));
    cin >> fds;

    map<ll, int> pos;

    int prox[3][3];
    prox[0][0] = 0;
    prox[0][1] = 2;
    prox[0][2] = 1;
    prox[1][0] = 2;
    prox[1][1] = 1;
    prox[1][2] = 0;
    prox[2][0] = 1;
    prox[2][1] = 0;
    prox[2][2] = 2;

    auto convert = [&](vi &a) {
        ll now = 0;
        ll p = 1;

        repv(i, a) {
            now += i * p;
            p *= 3;
        }

        return now;
    };

    auto getnext = [&](vi &a, vi &b) {
        ll now = 0;
        ll p = 1;

        rep(i, k) {
            now += prox[a[i]][b[i]] * p;
            p *= 3;
        }

        return now;
    };

    rep(i, n) {
        pos[convert(fds[i])] = i;
    }

    vi next(k);

    ll ans = 0;

    rep(i, n) {
        ll cnt = 0;
        // ll prev = 0;
        rep(j, n) {
            if (j == i) {
                continue;
            }
            auto itr = pos.find(getnext(fds[i], fds[j]));
            if (itr == pos.end() || itr->second < j) {
                continue;
            }
            cnt++;
        }

        if (cnt < 2) {
            continue;
        }

        ans += cnt * (cnt - 1) / 2;
    }

    cout << ans << '\n';
}
